<?php

/*************************************************************
*  TorrentFlux PHP Torrent Manager
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux.

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include_once("config.php");

function getAliasName($inName)
{
	$replaceItems = array(" ", ".", "-", "[", "]", "(", ")", "#", "&");
    $alias = str_replace($replaceItems, "_", $inName);
	$alias = strtolower($alias);
	$alias = str_replace("_torrent", "", $alias);

	return $alias;
}

function formatBytesToKBMGGB($inBytes)
{
	$rsize = "";
	if ($inBytes > (1024 * 1024 * 1024))
	{
		$rsize = round($inBytes / (1024 * 1024 * 1024), 2) . " GB";
	}
	elseif ($inBytes < 1024 * 1024)
	{
		$rsize = round($inBytes / 1024, 1) . " KB";
	}
	else
	{
		$rsize = round($inBytes / (1024 * 1024), 1) . " MB";
	}
	return $rsize;
}

function getFileFilter($inArray)
{
	$filter = "(\.".strtolower($inArray[0]).")|"; // used to hold the file type filter
	$filter .= "(\.".strtoupper($inArray[0]).")";
	// Build the file filter
	for($inx = 1; $inx < sizeof($inArray); $inx++)
	{
		$filter .= "|(\.".strtolower($inArray[$inx]).")";
		$filter .= "|(\.".strtoupper($inArray[$inx]).")";
	}
	$filter .= "$";
	return $filter;
}

function getOwner($file)
{
	global $cfg, $db;

	$rtnValue = "n/a";
	
	// Check log to see what user has a history with this file
	$sql = "SELECT user_id FROM tf_log WHERE file=".$db->qstr($file)." AND (action=".$db->qstr($cfg["constants"]["file_upload"])." OR action=".$db->qstr($cfg["constants"]["url_upload"]).") ORDER  BY time DESC";
	$user_id = $db->GetOne($sql);

	if($user_id != "")
	{
		$rtnValue = $user_id;
	}
	
	return $rtnValue;
}

function GetSpeedValue($inValue)
{
	$rtnValue = 0;
	$arTemp = split(" ", trim($inValue));
	
	if (is_numeric($arTemp[0]))
	{
		$rtnValue = $arTemp[0];
	}
	return $rtnValue;
}

function formatFreeSpace($freeSpace)
{
	$rtnValue = "";
	if ($freeSpace > 1024)
	{
		$rtnValue = number_format($freeSpace/1024, 2)." GB";
	}
	else
	{
		$rtnValue = number_format($freeSpace, 2)." MB";
	}
	
	return $rtnValue;
}

function checkSpeed($running)
{
	global $af;
	if($running == 0)
	{
		$outValue = "Torrent Not Running";
	}
	else
	{
		$outValue = $af->down_speed." - ".$af->up_speed;
	}
	return $outValue;
}

if($cfg["xmlinfo"] == true)
{
	header ("content-type: text/xml");
	echo "<?xml version='1.0' standalone='yes' ?>\n\n";
	echo "<torrent_flux>\n";
	echo "<torrents>\n";

	global $cfg;
	include_once("AliasFile.php");

	$dirName = $cfg["torrent_file_path"];
	$arList = array();
	$file_filter = getFileFilter($cfg["file_types_array"]);
	$handle = opendir($dirName);
	$lastUser = "";
	$arUserTorrent = array();
	$arListTorrent = array();

	while($entry = readdir($handle))
	{
		if ($entry != "." && $entry != "..")
		{
			if (is_dir($dirName."/".$entry))
			{
			}
			else
			{
				if (ereg($file_filter, $entry))
				{
					$key = filemtime($dirName."/".$entry).md5($entry);
					$arList[$key] = $entry;
				}
			}
		}
	}
	krsort($arList);
	foreach($arList as $entry)
	{
		$output = "";
		$estTime = "&nbsp;";
		$alias = getAliasName($entry).".stat";
		$af = new AliasFile($dirName.$alias, null);
		if(!file_exists($dirName.$alias))
		{
			$af->running = "2"; // file is new
			$af->size = getDownloadSize($dirName.$entry);
			$af->WriteFile();
		}
		$alias = getAliasName($entry).".stat";
		$cfg["total_upload"] = $cfg["total_upload"] + GetSpeedValue($af->up_speed);
		$cfg["total_download"] = $cfg["total_download"] + GetSpeedValue($af->down_speed);
		echo "<torrent>\n";
		echo "<name>".$entry."</name>\n";
		echo "<speeds>".checkSpeed($af->running)."</speeds>\n";
		echo "<size>".formatBytesToKBMGGB($af->size)."</size>\n";
		echo "<percent>".$af->percent_done."</percent>\n";
		echo "<sharing>".$af->sharing."</sharing>";
		echo "<remaining>".$af->time_left."</remaining>";
		echo "<transfered>".formatBytesToKBMGGB($af->downtotal)." - ".formatBytesToKBMGGB($af->uptotal)."</transfered>";
		echo "</torrent>\n";
	}
	closedir($handle);
	echo "</torrents>\n";
	echo "<tf_details>\n";
	echo "<total_speeds>".number_format($cfg["total_download"], 2)." - ".number_format($cfg["total_upload"], 2)."</total_speeds>\n";
	echo "<free_space>".formatFreeSpace($cfg['free_space'])."</free_space>";
	echo "</tf_details>\n";
	echo "</torrent_flux>";
}
else
{
	echo "go away";
}
?>